SystemOrganization addCategory: #ConfigurationOfMetaceller!

Object subclass: #ConfigurationOfMetaceller
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMetaceller'!

!ConfigurationOfMetaceller commentStamp: '<historical>' prior: 0!
A ConfigurationOfGTMetaceller is a mock configuration as GTMetaceller is part of the GT Toolbox.

It has all kinds of strange constructs, to allow for testing.!

!ConfigurationOfMetaceller class methodsFor: 'development support' stamp: 'DiegoLont 9/13/2013 10:48'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMetaceller class methodsFor: 'private' stamp: 'DiegoLont 9/13/2013 10:48'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMetaceller class methodsFor: 'private' stamp: 'DiegoLont 9/13/2013 10:48'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMetaceller class methodsFor: 'private' stamp: 'DiegoLont 9/13/2013 10:48'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMetaceller class methodsFor: 'metacello tool support' stamp: 'DiegoLont 9/13/2013 10:48'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMetaceller class methodsFor: 'loading' stamp: 'DiegoLont 9/13/2013 10:48'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMetaceller class methodsFor: 'loading' stamp: 'DiegoLont 9/13/2013 10:48'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMetaceller class methodsFor: 'loading' stamp: 'DiegoLont 9/13/2013 10:48'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMetaceller class methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:48'!
project

	^self new project! !

!ConfigurationOfMetaceller class methodsFor: 'development support' stamp: 'DiegoLont 9/13/2013 10:48'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMetaceller methodsFor: 'baselines' stamp: 'DiegoLont 9/17/2013 12:23'!
baseline01: aSpec
	<version: '0.1-baseline'>
	aSpec for: #common do: [ 
		aSpec blessing: #'baseline'.
		aSpec description: 'The group "gemstone" is just for testing. It should load fine in pharo. It also loads as part of the GT-Tools'.

		aSpec package: 'GT-Metaceller-Model';
			package: 'GT-Metaceller-Glamour' with: [ 
				aSpec requires: #( 'GT-Metaceller-Model' ) ];
			package: 'GT-Metaceller-Tests' with: [ 
				aSpec requires: #( 'GT-Metaceller-Model' ) ].
		aSpec
			group: 'Core' with: #( 'GT-Metaceller-Model' );
			group: 'Tests' with: #( 'GT-Metaceller-Tests' );
			group: 'Glamour' with: #( 'GT-Metaceller-Glamour' );
			group: 'All' with: #( 'Tests' 'Glamour' ) ].
	
	aSpec for: #gemstone do: [ 
		aSpec project: 'GlamourCore' with: [
				aSpec
					className: 'ConfigurationOfGlamour';
					file: 'ConfigurationOfGlamour';
					version: #development;
					loads: #('Core');
					repository: 'http://www.smalltalkhub.com/mc/Moose/Glamour/main' ].
		aSpec package: 'GT-Metaceller-Glamour' with: [ 
			aSpec requires: #( 'GlamourCore' ) ] ].

	aSpec for: #pharo do: [ 
		aSpec project: 'GlamourAll' with: [
				aSpec
					className: 'ConfigurationOfGlamour';
					file: 'ConfigurationOfGlamour';
					version: #development;
					loads: #('Extras' 'Morphic');
					repository: 'http://www.smalltalkhub.com/mc/Moose/Glamour/main' ].
		aSpec package: 'GT-Metaceller-Glamour' with: [ 
			aSpec requires: #( 'GlamourAll' ) ] ]! !

!ConfigurationOfMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:48'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfMetaceller methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:48'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMetaceller methodsFor: 'versions' stamp: 'DiegoLont 9/16/2013 11:17'!
version01: aSpec
	<version: '0.1' imports: #( '0.1-baseline')>
	aSpec for: #'common' do: [ 
		aSpec blessing: #'development' ]! !
